# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify Alma, CentOS, CentOS Stream and Rocky Linux as rhel
%if "%{__distinit}" == "a" || "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "cs" || "%{__distinit}" == "rl"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

Name:		perl-File-chdir
Version:	0.1011
Release:	21.%{__distinit}%{__distvers}
Summary:	A more sensible way to change directories
License:	GPL-1.0-or-later OR Artistic-1.0-Perl
URL:		https://metacpan.org/release/File-chdir
Source0:	https://cpan.metacpan.org/modules/by-module/File/File-chdir-%{version}.tar.gz
Patch0:		File-chdir-0.1011-pod-spell.patch
BuildArch:	noarch
# ======== Module Build ==========================
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	make
BuildRequires:	perl-generators
BuildRequires:	perl-interpreter
BuildRequires:	perl(ExtUtils::MakeMaker) >= 6.17
BuildRequires:	perl(warnings)
# ======== Module Runtime ========================
BuildRequires:	perl(Carp)
BuildRequires:	perl(Cwd) >= 3.16
BuildRequires:	perl(Exporter)
BuildRequires:	perl(File::Spec::Functions) >= 3.27
BuildRequires:	perl(strict)
BuildRequires:	perl(vars)
# ======== Regular Test Suite ====================
BuildRequires:	perl(File::Spec)
BuildRequires:	perl(Test::More) >= 0.88
# ======== Optional Tests ========================
BuildRequires:	perl(CPAN::Meta) >= 2.120900
# ======== Extra Tests ===========================
# Perl::Critic::Lax → Perl::Critic → PPIx::Regexp → Test::Kwalitee → Module::CPANTS::Analyse → File::chdir
# Test::Perl::Critic → Perl::Critic → PPIx::Regexp → Test::Kwalitee → Module::CPANTS::Analyse → File::chdir
%if 0%{?fedora} > 23 || 0%{?rhel} > 7
BuildRequires:	glibc-langpack-en
%endif
%if 0%{!?perl_bootstrap:1}
BuildRequires:	perl(Perl::Critic::Policy::Lax::ProhibitStringyEval::ExceptForRequire)
BuildRequires:	perl(Test::Perl::Critic)
%endif
BuildRequires:	perl(blib)
BuildRequires:	perl(English)
BuildRequires:	perl(File::Temp)
BuildRequires:	perl(IO::Handle)
BuildRequires:	perl(IPC::Open3)
BuildRequires:	perl(Pod::Coverage::TrustPod)
BuildRequires:	perl(Pod::Wordlist)
BuildRequires:	perl(Test::CPAN::Meta)
BuildRequires:	perl(Test::MinimumVersion)
BuildRequires:	perl(Test::Pod) >= 1.41
BuildRequires:	perl(Test::Pod::Coverage) >= 1.08
BuildRequires:	perl(Test::Portability::Files)
BuildRequires:	perl(Test::Spelling) >= 0.12, hunspell-en
BuildRequires:	perl(Test::Version) >= 1.002
# ======== Dependencies ==========================
%if 0%{?fedora} < 38 && 0%{?rhel} < 10
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
%endif

%description
Perl's chdir() has the unfortunate problem of being very, very, very
global. If any part of your program calls chdir() or if any library you
use calls chdir(), it changes the current working directory for the
whole program.

This sucks.

File::chdir gives you an alternative, $CWD and @CWD. These two variables
combine all the power of chdir(), File::Spec and Cwd.

%prep
%setup -q -n File-chdir-%{version}

# Some extra stopwords for the pod spelling check
%patch -P 0

# Avoid patch backup files that may result in unwanted dependencies
find . -name '*.orig' -delete

%build
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -delete
%{_fixperms} -c %{buildroot}

%check
make test
LANG=en_US make test TEST_FILES="$(echo $(find xt/ -name '*.t'))"

%files
%license LICENSE
%doc Changes CONTRIBUTING.mkdn README
%{perl_vendorlib}/File/
%{_mandir}/man3/File::chdir.3*

%changelog
* Tue Apr 18 2023 Paul Howarth <paul@city-fan.org> - 0.1011-21
- Use SPDX-format license tag
- Avoid use of deprecated patch syntax
- Use %%license unconditionally

* Sun Jun  9 2019 Paul Howarth <paul@city-fan.org> - 0.1011-9
- Perl 5.30 rebuild

* Fri Mar  8 2019 Paul Howarth <paul@city-fan.org> - 0.1011-8
- Switch upstream from search.cpan.org to metacpan.org
- Work around mock locale issues by adding buildreq glibc-langpack-en when
  running extra tests
- BR: perl-generators unconditionally
- BR: perl-interpreter rather than perl
- Drop support for EOL distributions prior to EL-6
  - Drop legacy BuildRoot: and Group: tags
  - Drop explicit %%clean section
  - Drop explicit buildroot cleaning in %%install section
  - Drop support for building with Cwd < 3.16
  - Drop support for building with File::Spec::Functions < 3.27
  - Drop support for building with Test::More < 0.88
  - Spell check back-end is always hunspell

* Mon Oct 10 2016 Paul Howarth <paul@city-fan.org> - 0.1011-1
- Update to 0.1011
  - Fixed POD typos
- Update patches as needed

* Tue Aug 23 2016 Paul Howarth <paul@city-fan.org> - 0.1010-5
- Fix FTBFS when perl is not in the minimal buildroot
- BR: perl-generators where available
- Simplify find commands using -delete

* Mon Feb  9 2015 Paul Howarth <paul@city-fan.org> - 0.1010-2
- Update to 0.1010
  - Updated distribution metadata and repo layout
  - Changed bugtracker to github
- Use hunspell rather than aspell on more recent distributions
- Avoid patch backup files that may result in unwanted dependencies
- Update patches as needed

* Thu Sep 25 2014 Paul Howarth <paul@city-fan.org> - 0.1009-1
- Update to 0.1009
  - Updated distribution metadata
- Update patch for building with old Test::More versions
- Add patch to add extra stopwords for the POD spelling check

* Tue Sep 16 2014 Paul Howarth <paul@city-fan.org> - 0.1008-5
- Drop support for building with ExtUtils::MakeMaker < 6.30
- Drop %%defattr, redundant since rpm 4.4
- Use %%license where possible

* Mon Dec  3 2012 Paul Howarth <paul@city-fan.org> - 0.1008-1
- Update to 0.1008
  - Fixed broken use of abs_path on Cygwin
  - README.PATCHING replaced by CONTRIBUTING

* Tue Sep 18 2012 Paul Howarth <paul@city-fan.org> - 0.1007-1
- Update to 0.1007
   - Fixed broken Pod link; reordered CAVEATS section
- Classify buildreqs by usage
- Run the extra tests too
- BR: perl(English), perl(Pod::Coverage::TrustPod), perl(Test::CPAN::Meta),
  perl(Perl::Critic::Policy::Lax::ProhibitStringyEval::ExceptForRequire),
  perl(Pod::Coverage::TrustPod), perl(Pod::Wordlist::hanekomu),
  perl(Test::CPAN::Meta), perl(Test::Perl::Critic), perl(Test::Pod),
  perl(Test::Pod::Coverage), perl(Test::Portability::Files),
  perl(Test::Spelling), aspell-en and perl(Test::Version) for the extra tests
- Update patch for building with old Test::More versions to cater for
  the extra tests

* Fri Jun  8 2012 Paul Howarth <paul@city-fan.org> - 0.1006-3
- Perl 5.16 rebuild

* Mon May 28 2012 Paul Howarth <paul@city-fan.org> - 0.1006-2
- Import from Fedora
- Add patches to support building on old distributions

* Wed Jan 11 2012 Petr Šabata <contyk@redhat.com> - 0.1006-1
- 0.1006 bump

* Sat Jun 18 2011 Iain Arnell <iarnell@gmail.com> - 0.1003-1
- Update to latest upstream version
- Clean up spec for modern rpmbuild

* Fri Jun 17 2011 Marcela Mašláňová <mmaslano@redhat.com> - 0.09-10
- Perl mass rebuild

* Tue Feb 08 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.09-9
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Thu Dec 16 2010 Marcela Maslanova <mmaslano@redhat.com> - 0.09-8
- Rebuild to fix problems with vendorarch/lib (#661697)

* Sat May 01 2010 Marcela Maslanova <mmaslano@redhat.com> - 0.09-7
- Mass rebuild with perl-5.12.0

* Fri Apr 30 2010 Marcela Maslanova <mmaslano@redhat.com> - 0.09-6
- Mass rebuild with perl-5.12.0

* Mon Dec  7 2009 Stepan Kasal <skasal@redhat.com> - 0.09-5
- Rebuild against perl 5.10.1

* Sat Jul 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.09-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Thu Feb 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.09-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Wed Mar  5 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 0.09-2
- Rebuild for new perl

* Thu Jan 17 2008 Ian Burrell <ianburrell@gmail.com> - 0.09-1
- Update to 0.09

* Thu Aug 16 2007 Ian M. Burrell <ianburrell@gmail.com> - 0.06-3
- Fix BuildRequires

* Tue Jun 27 2006 Ian M. Burrell <ianburrell@gmail.com> - 0.06-2
- Fix rpmlint warnings

* Thu Mar 30 2006 Ian Burrell <ianburrell@gmail.com> - 0.06-1
- Specfile autogenerated by cpanspec 1.64
